/*
 * Device2D_triangle.java
 *
 * Created on Nedee, 2004, oktber 24, 19:59
 */

package graphics.device;
import graphics.math.*;
import graphics.device.Device2D;
/**
 *
 * @author  Marek Mizanin
 */
public class Device2D_triangle extends Device2D
{
	public boolean cullFace=false;
	public boolean cullBackSet=true;	// set from out
	public boolean cullBack=true;		// set from glVertex, glBegin
	// for each line left and right border
	int left[];
	int right[];
	int leftC[];		// color
	int rightC[];
	int y0,y1;
	
	public Device2D_triangle(){}
	public Device2D_triangle(int sizeX_, int sizeY_)
	{
		super(sizeX_,sizeY_);
		
		left = new int[sizeY];
		right = new int[sizeY];
		leftC = new int[sizeY];
		rightC = new int[sizeY];
	}
	
	void makeBoundsF(vi a, vi b)
	{
		if(a.y==b.y)
			return;
		if(a.y>b.y)
		{
			vi temp = a;
			a = b;
			b = temp;
		}
		
		int count = b.y - a.y; 
		float dx = (float)(b.x - a.x)/(float)count;
		
		float x = a.x;
		for(int y=a.y; y<=b.y; y++)
		{
			if(y<0)
			{
				x += dx;
				continue;
			}
			if(y>=sizeY)
				return;
			
			int x_ = (int)Math.ceil(x);
			if(x_<left[y])
			{
				left[y]=x_;
			}
			if(x_-1>right[y])
			{
				right[y]=x_-1;
			}
			x += dx;		
		}
	}
	public void drawHorizontalLineF(int ax, int bx, int y)
	{
		if(ax<0)ax=0;
		if(bx>=sizeX)bx=sizeX-1;
		bx += y*sizeX;
		for(int i=ax+y*sizeX; i<=bx; i++)
			cBuf[i] = actual_c;
	}
	
	public void drawTriangleF(vi a, vi b, vi c)
	{
		if(cullFace)
		{
			vi ab_ = vi.sub(b,a);
			vi ac_ = vi.sub(c,a);
			if(cullBack)
			{
				if(ab_.x*ac_.y - ab_.y*ac_.x < 0)				
					return;
			}
			else
			{
				if(ab_.x*ac_.y - ab_.y*ac_.x > 0)				
					return;				
			}
		}
		
		y0 = sizeY;
		y1 = -1;
		if(a.y<y0) y0 = a.y; if(a.y>y1) y1 = a.y;
		if(b.y<y0) y0 = b.y; if(b.y>y1) y1 = b.y;
		if(c.y<y0) y0 = c.y; if(c.y>y1) y1 = c.y;
		if(y0<0) y0 = 0;
		if(y1>sizeY) y1 = sizeY;
		if(y0>=y1)return;
		
		for(int y=y0; y<y1; y++)
		{
			right[y] = -1;
			left[y] = sizeX;
		}
		
		makeBoundsF(a,b);
		makeBoundsF(b,c);
		makeBoundsF(c,a);
		for(int y=y0; y<y1; y++)
		{
			if(left[y]<=right[y])
				drawHorizontalLineF(left[y],right[y],y);
		}
	}
	
	
	void makeBoundsG(vi a, vi b, int ac, int bc)
	{
		if(a.y==b.y)
			return;
		if(a.y>b.y)
		{
			vi temp = a;
			a = b;
			b = temp;
			int tempc = ac;
			ac = bc;
			bc = tempc;
		}
		
		int count = b.y - a.y; 
		float dx = (float)(b.x - a.x)/(float)count;
		
		float x = a.x;
		for(int y=a.y; y<=b.y; y++)
		{
			if(y<0)
			{
				x += dx;
				continue;
			}
			if(y>=sizeY)
				return;
			
			int x_ = (int)Math.ceil(x);
			if(x_<left[y])
			{
				left[y]=x_;
				leftC[y] = col.get(ac, bc, count, y-a.y);
			}
			if(x_-1>right[y])
			{
				right[y]=x_-1;
				rightC[y] = col.get(ac, bc, count, y-a.y);
			}
			x += dx;		
		}
	}
	
	public void drawHorizontalLineG(int ax, int bx, int y, int ac, int bc)
	{
	/*	for(int x=ax; x<=bx; x++)
			if(x>=0 && x<sizeX)
				cBuf[y*sizeX+x] |= col.get( ac, bc, ax, bx, x);*/
		int bx1 = bx-ax;
		if(bx1==0)
		{
			if(ax>=0 && ax<sizeX)
				cBuf[y*sizeX+ax] = col.between(ac ,bc);
			return;	
		}
		int ax1 = ax;
		if(ax<0)ax=0;
		if(bx>=sizeX)bx=sizeX-1;

		int base = y*sizeX;
		for(int x=ax; x<=bx; x++)
			cBuf[x+base] = col.get( ac, bc, bx1, x-ax1);
	}
	
	public void drawTriangleG(vi a, vi b, vi c, int ac, int bc, int cc)
	{
		//	a.x*b.y - a.y*b.x );
		
		if(cullFace)
		{
			vi ab_ = vi.sub(b,a);
			vi ac_ = vi.sub(c,a);
			if(cullBack)
			{
				if(ab_.x*ac_.y - ab_.y*ac_.x < 0)				
					return;
			}
			else
			{
				if(ab_.x*ac_.y - ab_.y*ac_.x > 0)				
					return;				
			}
		}
		
		y0 = sizeY;
		y1 = -1;
		if(a.y<y0) y0 = a.y; if(a.y>y1) y1 = a.y;
		if(b.y<y0) y0 = b.y; if(b.y>y1) y1 = b.y;
		if(c.y<y0) y0 = c.y; if(c.y>y1) y1 = c.y;
		if(y0<0) y0 = 0;
		if(y1>sizeY) y1 = sizeY;
		if(y0>=y1)return;
		
		for(int y=y0; y<y1; y++)
		{
			right[y] = -1;
			left[y] = sizeX;
		}
		
		makeBoundsG(a,b,ac,bc);
		makeBoundsG(b,c,bc,cc);
		makeBoundsG(c,a,cc,ac);
		for(int y=y0; y<y1; y++)
		{
			if(left[y]<=right[y])
				drawHorizontalLineG(left[y],right[y],y,leftC[y],rightC[y]);
		}
	}
}
