/*
 * Sphere.java
 *
 * Created on Nedee, 2004, oktber 31, 21:58
 */

package graphics.geometry;
import java.math.*;
import java.util.*;
import graphics.math.*;
import graphics.device.GL;
/**
 *
 * @author  Marek Mizanin
 */
public class Sphere
{
	v vertexs[];
	v normals[];
	int del_uhol_x_;
	int del_uhol_y_;
	
	public Sphere(){}
	public void Init(int del_uhol_x, int del_uhol_y, float size)
	{
		del_uhol_x_ = del_uhol_x;
		del_uhol_y_ = del_uhol_y;
		// del_uhol_x * 2*(del_uhol_y+1) vertexs
		int count = del_uhol_x*2*(del_uhol_y+1);
		vertexs = new v[count];
		for(int i=0; i<count; i++)vertexs[i] = new v();
		normals = new v[count];
		for(int i=0; i<count; i++)normals[i] = new v();
		
		int index=0;
		v a = new v(),b = new v(),ay = new v(),by = new v();
		float dy=360.f/del_uhol_y;
		float dx=180.f*v.PI180/del_uhol_x;
		for(int x=0; x<del_uhol_x; x++)
		{
			float tx = (float)x/(float)del_uhol_x;
			float ang = tx*180.f*v.PI180-90.f*v.PI180;
			a.set( 0, (float)Math.sin(ang) , (float)Math.cos(ang));
			b.set( 0, (float)Math.sin(ang+dx), (float)Math.cos(ang+dx));

		//	gl.glBegin( GL.GL_LINE_STRIP);
		//	gl.glBegin( GL.GL_TRIANGLE_STRIP);

		//	gl.glTexCoord2f( 0, tx);
			normals[index].set(a);
			vertexs[index++].set(v.mul(size,a));
			
		//	gl.glTexCoord2f( 0, tx+1.f/del_uhol_x);
			normals[index].set(b);
			vertexs[index++].set(v.mul(size,b));

			for(int y=1; y<del_uhol_y+1; y++)
			{
				float ty = (float)y/(float)del_uhol_y;
				ay.set(a);	ay.RotY( ty*360.f);
				by.set(b);	by.RotY( ty*360.f);
			//	gl.glTexCoord2f( ty, tx);
				normals[index].set(ay);
				vertexs[index++].set(v.mul(size,ay));
				
			//	gl.glTexCoord2f( ty, tx+1.f/del_uhol_x);
				normals[index].set(by);
				vertexs[index++].set(v.mul(size,by));
			}
		//	gl.glEnd();
		}			
	}
	public void Draw(GL gl)
	{
		int index=0;
		for(int x=0; x<del_uhol_x_; x++)
		{
			gl.glBegin( GL.GL_TRIANGLE_STRIP);
			gl.glNormal3fv(normals[index]);
			gl.glVertex3fv(vertexs[index++]);
			
			gl.glNormal3fv(normals[index]);
			gl.glVertex3fv(vertexs[index++]);
			
			for(int y=1; y<del_uhol_y_+1; y++)
			{
				gl.glNormal3fv(normals[index]);
				gl.glVertex3fv(vertexs[index++]);

				gl.glNormal3fv(normals[index]);
				gl.glVertex3fv(vertexs[index++]);				
			}
			gl.glEnd();
		}
	}
	
	public static void DrawSphereBase(GL gl, int del_uhol_x, int del_uhol_y, float size)
	{
		// del_uhol_x krat 2*(del_uhol_y+1) bodov
		v a = new v(),b = new v(),ay = new v(),by = new v();
		float dy=360.f/del_uhol_y;
		float dx=180.f*v.PI180/del_uhol_x;
		for(int x=0; x<del_uhol_x; x++)
		{
			float tx = (float)x/(float)del_uhol_x;
			float ang = tx*180.f*v.PI180-90.f*v.PI180;
			a.set( 0, (float)Math.sin(ang) , (float)Math.cos(ang));
			b.set( 0, (float)Math.sin(ang+dx), (float)Math.cos(ang+dx));

		//	gl.glBegin( GL.GL_LINE_STRIP);
			gl.glBegin( GL.GL_TRIANGLE_STRIP);

		//	gl.glTexCoord2f( 0, tx);
			gl.glNormal3fv(a);
			gl.glVertex3fv(v.mul(size,a));
		//	gl.glTexCoord2f( 0, tx+1.f/del_uhol_x);
			gl.glNormal3fv(b);
			gl.glVertex3fv(v.mul(size,b));

			for(int y=1; y<del_uhol_y+1; y++)
			{
				float ty = (float)y/(float)del_uhol_y;
				ay.set(a);	ay.RotY( ty*360.f);
				by.set(b);	by.RotY( ty*360.f);
			//	gl.glTexCoord2f( ty, tx);
				gl.glNormal3fv(new v(ay));
				gl.glVertex3fv(v.mul(size,ay));
			//	gl.glTexCoord2f( ty, tx+1.f/del_uhol_x);
				gl.glNormal3fv(new v(by));
				gl.glVertex3fv(v.mul(size,by));
			}
			gl.glEnd();
		}
	}
	
}
