/*
 * col.java
 *
 * Created on Piatok, 2004, oktber 22, 21:00
 */

package graphics.math;

/**
 *
 * @author  Marek Mizanin
 */
// Color class
public class col
{
	public static int make(int r, int g, int b)
	{
		return (r<<16)|(g<<8)|b;
	}
	public static int make(float r, float g, float b)
	{
		return (((int)(r*255.f))<<16)|(((int)(g*255.f))<<8)|((int)(b*255.f));
	}
	
	public static int setR(int c, int r){ return (c&0x00ffff)|r;}
	public static int setG(int c, int g){ return (c&0xff00ff)|g;}
	public static int setB(int c, int b){ return (c&0xffff00)|b;}	
	
	public static int getR(int c){ return (c>>16)&0xff;}
	public static int getG(int c){ return (c>>8) &0xff;}
	public static int getB(int c){ return  c     &0xff;}	
	
	public static int add(int a, int c)
	{
		int r = (a&0xff0000) + (c&0xff0000);
		if(r>0xff0000)r = 0xff0000;
		int g = (a&0x00ff00) + (c&0x00ff00);
		if(g>0x00ff00)r |= 0x00ff00;
		else r|= g;
		g = (a&0x0000ff) + (c&0x0000ff);
		if(g>0x0000ff)r |= 0x0000ff;
		else r |= g;
		return r;
	}
	public static int mul(int a, int c)
	{
		return (((((a&0xff0000)>>16) * ((c&0xff0000)>>16))/255)<<16)&0xff0000 |
		       (((((a&0x00ff00)>> 8) * ((c&0x00ff00)>> 8))/255)<< 8)&0x00ff00 |
		       (((a&0x0000ff) * (c&0x0000ff))/255)&0x0000ff;
	}
	public static int mul(int a, float b)
	{
		return (((int)((float)((a&0xff0000)>>16)*b))<<16)&0xff0000 |
		       (((int)((float)((a&0x00ff00)>> 8)*b))<< 8)&0x00ff00 |
			   ( (int)((float) (a&0x0000ff)     *b))     &0x0000ff;
	}
	public static int get(int a, int c, float t)	// t = [0,1]
	{
		int out;
		float t0 = 1.f-t;
		out  = (int)((float)getB(a)*t0+(float)getB(c)*t);
		out |= ((int)((float)getG(a)*t0+(float)getG(c)*t))<<8;
		return (out | (((int)((float)getR(a)*t0+(float)getR(c)*t))<<16));
	}
	
	/** xs - start
		xe - end
		xa - actual
		must by:    
			- xs<xe, xe-xs>0
			- xs<=xa<=xe */
	public static int get(int a, int c, int xs, int xe, int xa)		
	{
		xe -= xs;
		xa -= xs;
		int x0 = xe-xa;
		
		int r = (getR(a)*x0 + getR(c)*xa)/xe;
		int g = (getG(a)*x0 + getG(c)*xa)/xe;
		int b = (getB(a)*x0 + getB(c)*xa)/xe;
		return make(r,g,b);
	}
	
	public static int get(int a, int c, int xe, int xa)		// xe>0, xa<=xe
	{
		int x0 = xe-xa;
	//	int r = (getR(a)*x0 + getR(c)*xa)/xe;
	//	int g = (getG(a)*x0 + getG(c)*xa)/xe;
	//	int b = (getB(a)*x0 + getB(c)*xa)/xe;
	//	return make(r,g,b);
	//	int r = ((((a>>16)&0xff)*x0 + ((c>>16)&0xff)*xa)/xe)<<16;
	//	int g = (((a>> 8)&0xff)*x0 + ((c>> 8)&0xff)*xa)/xe;
	//	int b = (((a    )&0xff)*x0 + ((c    )&0xff)*xa)/xe;
	//	return (r<<16)|(g<<8)|b;
		return (((((a>>16)&0xff)*x0 + ((c>>16)&0xff)*xa)/xe)<<16)|
		       (((((a>> 8)&0xff)*x0 + ((c>> 8)&0xff)*xa)/xe)<<8)|
			   (((a    )&0xff)*x0 + ((c    )&0xff)*xa)/xe;
	}	
	
	public static int between(int a, int c)
	{
		int r = (getR(a) + getR(c))>>1;
		int g = (getG(a) + getG(c))>>1;
		int b = (getB(a) + getB(c))>>1;
		return make(r,g,b);
	}
}
